View Issue Details

IDProjectCategoryView StatusLast Update
0037829FPCCompilerpublic2020-09-28 21:57
ReporterThaddy de Koning Assigned ToFlorian  
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionno change required 
Product Version3.3.1 
Summary0037829: ISO mode does not accept string.
DescriptionIn example attached to 0037823, when you compile it by replacing rawbytestring with string, it does not compile.
If you replace it with shortstring it does compile. ISO does not know shortstring, all strings are shortstring by default and identified by the string keyword.
qt.pas(8,8) Error: (5000) Identifier not found "string"

Steps To Reproduce{$MODE ISO}{$IMPLICIT EXCETIONS OFF}
{$Q+}{$H-}
program gt;
  label 1;
  procedure jump;
  var
    a: integer;
    b: string[30];
  begin
    b := 'nanu';
    writeln('nanu');
    goto 1
  end;
begin
  jump;
  writeln('not jumped!');
1:
writeln('jumped!')
end.
Additional Informationqt.pas(8,8) Error: (5000) Identifier not found "string"

(I agree with Florian that managed types should not be allowed in ISO mode)
TagsNo tags attached.
Fixed in Revision
FPCOldBugId
FPCTarget-
Attached Files

Activities

Thaddy de Koning

2020-09-28 08:01

reporter   ~0125915

Last edited: 2020-09-28 17:14

View 4 revisions

Note I already specified {$H-} explicitly, but for ISO that should be implicit. And there is a space copied in, {$implicitexception off}
Als note I did not specify revision and platform:
Free Pascal Compiler version 3.3.1-r46970 [2020/09/27] for arm and now Free Pascal Compiler version 3.3.1-r46983 [2020/09/28] for arm
Both expose this error. Seems a regression.
It also does not work with just "string" which should also be accepted.

Florian

2020-09-28 21:57

administrator   ~0125941

ISO Pascal does know "string-types" (array[1...x] of char) but neither the string keyword nor is a string type predefined

Issue History

Date Modified Username Field Change
2020-09-28 07:59 Thaddy de Koning New Issue
2020-09-28 08:01 Thaddy de Koning Note Added: 0125915
2020-09-28 08:05 Thaddy de Koning Note Edited: 0125915 View Revisions
2020-09-28 09:17 Thaddy de Koning Note Edited: 0125915 View Revisions
2020-09-28 17:14 Thaddy de Koning Note Edited: 0125915 View Revisions
2020-09-28 21:57 Florian Assigned To => Florian
2020-09-28 21:57 Florian Status new => resolved
2020-09-28 21:57 Florian Resolution open => no change required
2020-09-28 21:57 Florian FPCTarget => -
2020-09-28 21:57 Florian Note Added: 0125941